
# include <iostream>
# include <memory>
# include <list>

namespace Kitchen
{
	class Salad
	{
	public:
		virtual ~Salad()
		{
		}
		
		virtual void print() const = 0; // Pure virtual.
	};



	class Olivier : public Salad
	{
	public:
		virtual void print() const
		{
			std::cout << "Olivier." << std::endl;
		}
	};



	class Vinegret : public Salad
	{
	public:
		virtual void print() const
		{
			std::cout << "Vinegret." << std::endl;
		}
	};



	class FruitSalad : public Salad
	{
	};



	class Rojak : public FruitSalad
	{
	public:
		virtual void print() const
		{
			std::cout << "Rojak." << std::endl;
		}
	};



	class SomTam : public FruitSalad
	{
	public:
		virtual void print() const
		{
			std::cout << "Som tam." << std::endl;
		}
	};
}



int main()
{
	using namespace Kitchen;

	typedef std::unique_ptr<Salad> salad_ptr;
	std::list<salad_ptr> salads;
	salads.push_back(salad_ptr(new Salad));
	salads.push_back(salad_ptr(new Olivier));
	salads.push_back(salad_ptr(new Vinegret));
	salads.push_back(salad_ptr(new FruitSalad));
	salads.push_back(salad_ptr(new Rojak));
	salads.push_back(salad_ptr(new SomTam));

	for (auto& salad : salads)
	{
		salad->print();
	}

	return 0;
}
